diff --git a/drivers/video/sunxi/lcd_fb/include.h b/drivers/video/sunxi/lcd_fb/include.h
index de95a0dc1..5a3eef03d 100644
--- a/drivers/video/sunxi/lcd_fb/include.h
+++ b/drivers/video/sunxi/lcd_fb/include.h
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Copyright (c) 2007-2019 Allwinnertech Co., Ltd.
@@ -48,12 +48,15 @@
 #include <linux/of_device.h>
 #include <linux/of_gpio.h>
 #include <linux/of_iommu.h>
+#include <linux/of.h>
+#include <linux/of_graph.h>
 #include <linux/of_irq.h>
 #include <linux/of_platform.h>
 #include <linux/platform_device.h>
 #include <linux/platform_device.h>
 #include <linux/pwm.h>
 #include <linux/regulator/consumer.h>
+#include <linux/version.h>
 #include <linux/sched.h> /* wake_up_process() */
 #include <linux/slab.h>
 #include <linux/timer.h>
@@ -63,154 +66,146 @@
 #include <sunxi-clk.h>
 #include <sunxi-gpio.h>
 #include <linux/pinctrl/consumer.h>
+#include <linux/gpio/machine.h>
 #include <linux/clk-provider.h>
 #include <linux/spi/spidev.h>
 #include <linux/spi/spi.h>
 #include <linux/spi/sunxi-spi.h>
 #include "lcd_fb_feature.h"
 
-#define LCD_GAMMA_TABLE_SIZE (256 * sizeof(unsigned int))
+#define LCD_GAMMA_TABLE_SIZE (256 * sizeof(u32))
 #define LCD_FB_DEBUG_LEVEL 0
-#define LCD_FB_MAX 2 /* TODO:auto detect */
 
 #if LCD_FB_DEBUG_LEVEL == 1
-#define lcd_fb_inf(msg...) do { \
-			pr_warn("[LCD_FB] %s,line:%d:", __func__, __LINE__); \
-			pr_warn(msg); \
-	} while (0)
-#define lcd_fb_msg(msg...) do { \
-			pr_warn("[LCD_FB] %s,line:%d:", __func__, __LINE__); \
-			pr_warn(msg); \
-	} while (0)
-#define lcd_fb_here
-#define lcd_fb_dbg(msg...)
+#define LCDFB_INF(fmt, arg...)                                                 \
+	printk("sunxi:lcd_fb:[INFO] %s,line:%d - " fmt, __func__, __LINE__,    \
+	       ##arg)
+#define LCDFB_MSG(fmt, arg...)                                                 \
+	printk("sunxi:lcd_fb:[MSG ] %s,line:%d - " fmt, __func__, __LINE__,    \
+	       ##arg)
+#define LCDFB_HERE printk("[LCD_FB] %s,line:%d", __func__, __LINE__)
+#define LCDFB_DBG(fmt, arg...)                                                 \
+	printk("sunxi:lcd_fb:[DBG ] %s,line:%d - " fmt, __func__, __LINE__,    \
+	       ##arg)
 #elif LCD_FB_DEBUG_LEVEL == 2
-#define lcd_fb_inf(msg...) do { \
-			pr_warn("[LCD_FB] %s,line:%d:", __func__, __LINE__); \
-			pr_warn(msg); \
-	} while (0)
-#define lcd_fb_here do { \
-			pr_warn("[LCD_FB] %s,line:%d\n", __func__, __LINE__);\
-	} while (0)
-#define lcd_fb_dbg(msg...)  do { \
-			pr_warn("[LCD_FB] %s,line:%d:", __func__, __LINE__); \
-			pr_warn(msg); \
-	} while (0)
+#define LCDFB_INF(fmt, arg...)                                                 \
+	printk("sunxi:lcd_fb:[INFO] %s,line:%d - " fmt, __func__, __LINE__,    \
+	       ##arg)
+#define LCDFB_HERE printk("[LCD_FB] %s,line:%d", __func__, __LINE__)
+#define LCDFB_DBG(fmt, arg...)                                                 \
+	printk("sunxi:lcd_fb:[DBG ] %s,line:%d - " fmt, __func__, __LINE__,    \
+	       ##arg)
 #else
-#define lcd_fb_inf(msg...)
-#define lcd_fb_msg(msg...)
-#define lcd_fb_here
-#define lcd_fb_dbg(msg...)
+#define LCDFB_INF(fmt, arg...)
+#define LCDFB_MSG(fmt, arg...)
+#define LCDFB_HERE
+#define LCDFB_DBG(fmt, arg...)
 #endif
 
-#define lcd_fb_wrn(msg...) do { \
-			pr_warn("[LCD_FB] %s,line:%d:", __func__, __LINE__); \
-			pr_warn(msg); \
-		} while (0)
+#define LCDFB_WRN(fmt, arg...) printk("sunxi:lcd_fb:[WARN]: " fmt, ##arg)
 
 #if defined(SUPPORT_DBI_IF)
-#define DBI_READ(dbi_mode)			(dbi_mode |= (SUNXI_DBI_COMMAND_READ))
-#define DBI_WRITE(dbi_mode)			(dbi_mode &= ~(SUNXI_DBI_COMMAND_READ))
-#define DBI_LSB_FIRST(dbi_mode)		(dbi_mode |= SUNXI_DBI_LSB_FIRST)
-#define DBI_MSB_FIRST(dbi_mode)		(dbi_mode &= ~SUNXI_DBI_LSB_FIRST)
-#define	DBI_TR_VIDEO(dbi_mode)		(dbi_mode |= SUNXI_DBI_TRANSMIT_VIDEO)
-#define	DBI_TR_COMMAND(dbi_mode)	(dbi_mode &= ~(SUNXI_DBI_TRANSMIT_VIDEO))
-#define DBI_DCX_DATA(dbi_mode)		(dbi_mode |= SUNXI_DBI_DCX_DATA)
-#define DBI_DCX_COMMAND(dbi_mode)	(dbi_mode &= ~(SUNXI_DBI_DCX_DATA))
+#define DBI_READ(dbi_mode) (dbi_mode |= (SUNXI_DBI_COMMAND_READ))
+#define DBI_WRITE(dbi_mode) (dbi_mode &= ~(SUNXI_DBI_COMMAND_READ))
+#define DBI_LSB_FIRST(dbi_mode) (dbi_mode |= SUNXI_DBI_LSB_FIRST)
+#define DBI_MSB_FIRST(dbi_mode) (dbi_mode &= ~SUNXI_DBI_LSB_FIRST)
+#define DBI_TR_VIDEO(dbi_mode) (dbi_mode |= SUNXI_DBI_TRANSMIT_VIDEO)
+#define DBI_TR_COMMAND(dbi_mode) (dbi_mode &= ~(SUNXI_DBI_TRANSMIT_VIDEO))
+#define DBI_DCX_DATA(dbi_mode) (dbi_mode |= SUNXI_DBI_DCX_DATA)
+#define DBI_DCX_COMMAND(dbi_mode) (dbi_mode &= ~(SUNXI_DBI_DCX_DATA))
 #endif
 
-typedef void (*LCD_FUNC) (unsigned int sel);
-struct disp_lcd_function {
+typedef void (*LCD_FUNC)(u32 sel);
+struct sunxi_lcd_fb_disp_lcd_function {
 	LCD_FUNC func;
-	unsigned int delay;
+	u32 delay;
 };
 
 #define LCD_MAX_SEQUENCES 7
-struct disp_lcd_flow {
-	struct disp_lcd_function func[LCD_MAX_SEQUENCES];
-	unsigned int func_num;
-	unsigned int cur_step;
+struct sunxi_lcd_fb_disp_lcd_flow {
+	struct sunxi_lcd_fb_disp_lcd_function func[LCD_MAX_SEQUENCES];
+	u32 func_num;
+	u32 cur_step;
 };
 
-struct panel_extend_para {
-	unsigned int lcd_gamma_en;
-	unsigned int lcd_gamma_tbl[256];
-	unsigned int lcd_cmap_en;
-	unsigned int lcd_cmap_tbl[2][3][4];
-	unsigned int lcd_bright_curve_tbl[256];
+struct sunxi_lcd_fb_panel_extend_para {
+	u32 lcd_gamma_en;
+	u32 lcd_gamma_tbl[256];
+	u32 lcd_cmap_en;
+	u32 lcd_cmap_tbl[2][3][4];
+	u32 lcd_bright_curve_tbl[256];
 };
 
-struct disp_rect {
+struct sunxi_lcd_fb_disp_rect {
 	int x;
 	int y;
-	unsigned int width;
-	unsigned int height;
+	u32 width;
+	u32 height;
 };
 
-
-struct disp_lcd_panel_fun {
-	void (*cfg_panel_info)(struct panel_extend_para *info);
-	int (*cfg_open_flow)(unsigned int sel);
-	int (*cfg_close_flow)(unsigned int sel);
-	int (*lcd_user_defined_func)(unsigned int sel, unsigned int para1,
-				     unsigned int para2, unsigned int para3);
-	int (*set_bright)(unsigned int sel, unsigned int bright);
-	int (*blank)(unsigned int sel, unsigned int en);
-	int (*set_var)(unsigned int sel, struct fb_info *info);
-	int (*set_addr_win)(unsigned int sel, int x, int y, int width, int height);
+struct sunxi_lcd_fb_disp_lcd_panel_fun {
+	void (*cfg_panel_info)(struct sunxi_lcd_fb_panel_extend_para *info);
+	int (*cfg_open_flow)(u32 sel);
+	int (*cfg_close_flow)(u32 sel);
+	int (*lcd_user_defined_func)(u32 sel, u32 para1, u32 para2, u32 para3);
+	int (*set_bright)(u32 sel, u32 bright);
+	int (*blank)(u32 sel, u32 en);
+	int (*set_var)(u32 sel, struct fb_info *info);
+	int (*set_addr_win)(u32 sel, int x, int y, int width, int height);
 };
 
-
-struct disp_video_timings {
-	unsigned int vic;	/* video information code */
-	unsigned int tv_mode;
-	unsigned int pixel_clk;
-	unsigned int pixel_repeat; /* pixel repeat (pixel_repeat+1) times */
-	unsigned int x_res;
-	unsigned int y_res;
-	unsigned int hor_total_time;
-	unsigned int hor_back_porch;
-	unsigned int hor_front_porch;
-	unsigned int hor_sync_time;
-	unsigned int ver_total_time;
-	unsigned int ver_back_porch;
-	unsigned int ver_front_porch;
-	unsigned int ver_sync_time;
-	unsigned int hor_sync_polarity;	/* 0: negative, 1: positive */
-	unsigned int ver_sync_polarity;	/* 0: negative, 1: positive */
+struct sunxi_lcd_fb_disp_video_timings {
+	u32 vic; /* video information code */
+	u32 tv_mode;
+	u32 pixel_clk;
+	u32 pixel_repeat; /* pixel repeat (pixel_repeat+1) times */
+	u32 x_res;
+	u32 y_res;
+	u32 hor_total_time;
+	u32 hor_back_porch;
+	u32 hor_front_porch;
+	u32 hor_sync_time;
+	u32 ver_total_time;
+	u32 ver_back_porch;
+	u32 ver_front_porch;
+	u32 ver_sync_time;
+	u32 hor_sync_polarity; /* 0: negative, 1: positive */
+	u32 ver_sync_polarity; /* 0: negative, 1: positive */
 	bool b_interlace;
-	unsigned int vactive_space;
-	unsigned int trd_mode;
-	unsigned long      dclk_rate_set; /* unit: hz */
+	u32 vactive_space;
+	u32 trd_mode;
+	unsigned long dclk_rate_set; /* unit: hz */
 	unsigned long long frame_period; /* unit: ns */
-	int                start_delay; /* unit: line */
+	int start_delay; /* unit: line */
 };
 
-enum disp_fb_mode {
+enum sunxi_lcd_fb_disp_fb_mode {
 	FB_MODE_SCREEN0 = 0,
 	FB_MODE_SCREEN1 = 1,
 	FB_MODE_SCREEN2 = 2,
-	FB_MODE_DUAL_SAME_SCREEN_TB = 3,/* two screen, top buffer for screen0, bottom buffer for screen1 */
-	FB_MODE_DUAL_DIFF_SCREEN_SAME_CONTENTS = 4,/* two screen, they have same contents; */
+	FB_MODE_DUAL_SAME_SCREEN_TB =
+		3, /* two screen, top buffer for screen0, bottom buffer for screen1 */
+	FB_MODE_DUAL_DIFF_SCREEN_SAME_CONTENTS =
+		4, /* two screen, they have same contents; */
 };
 
-struct disp_fb_create_info {
-	enum disp_fb_mode fb_mode;
-	unsigned int buffer_num;
-	unsigned int width;
-	unsigned int height;
+struct sunxi_lcd_fb_disp_fb_create_info {
+	enum sunxi_lcd_fb_disp_fb_mode fb_mode;
+	u32 buffer_num;
+	u32 width;
+	u32 height;
 
-	unsigned int output_width;  /* used when scaler mode */
-	unsigned int output_height; /* used when scaler mode */
+	u32 output_width; /* used when scaler mode */
+	u32 output_height; /* used when scaler mode */
 };
 
-
-enum disp_lcd_if {
+enum sunxi_lcd_fb_disp_lcd_if {
 	LCD_FB_IF_SPI = 0,
 	LCD_FB_IF_DBI = 1,
+	LCD_FB_IF_QSPI = 2,
 };
 
-enum lcd_fb_dbi_if {
+enum sunxi_lcd_fb_dbi_if {
 	LCD_FB_L3I1 = 0x0,
 	LCD_FB_L3I2 = 0x1,
 	LCD_FB_L4I1 = 0x2,
@@ -218,8 +213,14 @@ enum lcd_fb_dbi_if {
 	LCD_FB_D2LI = 0x4,
 };
 
-enum lcdfb_pixel_format {
-	LCDFB_FORMAT_ARGB_8888 = 0x00,	/* MSB  A-R-G-B  LSB */
+enum sunxi_lcd_fb_qspi_if {
+	LCD_FB_QSPI_LANE1 = 0x0,
+	LCD_FB_QSPI_LANE2 = 0x1,
+	LCD_FB_QSPI_LANE4 = 0x2,
+};
+
+enum sunxi_lcd_fb_pixel_format {
+	LCDFB_FORMAT_ARGB_8888 = 0x00, /* MSB  A-R-G-B  LSB */
 	LCDFB_FORMAT_ABGR_8888 = 0x01,
 	LCDFB_FORMAT_RGBA_8888 = 0x02,
 	LCDFB_FORMAT_BGRA_8888 = 0x03,
@@ -241,7 +242,7 @@ enum lcdfb_pixel_format {
 	LCDFB_FORMAT_BGRA_5551 = 0x13,
 };
 
-enum lcdfb_dbi_fmt {
+enum sunxi_lcd_fb_dbi_fmt {
 	LCDFB_DBI_RGB111 = 0x0,
 	LCDFB_DBI_RGB444 = 0x1,
 	LCDFB_DBI_RGB565 = 0x2,
@@ -249,130 +250,143 @@ enum lcdfb_dbi_fmt {
 	LCDFB_DBI_RGB888 = 0x4,
 };
 
-struct disp_panel_para {
-	enum disp_lcd_if lcd_if;
-	enum lcd_fb_dbi_if dbi_if;
-	unsigned int lcd_spi_bus_num;
-
-	unsigned int lcd_data_speed;
-	unsigned int lcd_x;	/* horizontal resolution */
-	unsigned int lcd_y;	/* vertical resolution */
-	unsigned int lcd_width;	/* width of lcd in mm */
-	unsigned int lcd_height;	/* height of lcd in mm */
-
-	unsigned int lcd_pwm_used;
-	unsigned int lcd_pwm_ch;
-	unsigned int lcd_pwm_freq;
-	unsigned int lcd_pwm_pol;
-	enum lcdfb_pixel_format lcd_pixel_fmt;
-	enum lcdfb_dbi_fmt lcd_dbi_fmt;
-	unsigned int lcd_dbi_clk_mode;
-	unsigned int lcd_dbi_te;
-	unsigned int fb_buffer_num;
+struct sunxi_lcd_fb_disp_panel_para {
+	enum sunxi_lcd_fb_disp_lcd_if lcd_if;
+	enum sunxi_lcd_fb_dbi_if dbi_if;
+	enum sunxi_lcd_fb_qspi_if qspi_if;
+
+	u32 lcd_data_speed;
+	u32 lcd_x; /* horizontal resolution */
+	u32 lcd_y; /* vertical resolution */
+	u32 lcd_width; /* width of lcd in mm */
+	u32 lcd_height; /* height of lcd in mm */
+
+	u32 lcd_pwm_used;
+	u32 lcd_pwm_ch;
+	u32 lcd_pwm_freq;
+	u32 lcd_pwm_pol;
+	enum sunxi_lcd_fb_pixel_format lcd_pixel_fmt;
+	enum sunxi_lcd_fb_dbi_fmt lcd_dbi_fmt;
+	u32 lcd_dbi_clk_mode;
+	u32 lcd_dbi_te;
+	u32 fb_buffer_num;
 
 	enum sunxi_dbi_src_seq lcd_rgb_order;
-	unsigned int lcd_fps;
+	u32 lcd_fps;
 
-	unsigned int lcd_frm;
-	unsigned int lcd_gamma_en;
-	unsigned int lcd_bright_curve_en;
-	unsigned int lines_per_transfer;
+	u32 lcd_frm;
+	u32 lcd_gamma_en;
+	u32 lcd_bright_curve_en;
+	u32 lines_per_transfer;
 
-	char lcd_size[8];	/* e.g. 7.9, 9.7 */
-	char lcd_model_name[32];
+	u8 bpp;
 
+	char lcd_size[8]; /* e.g. 7.9, 9.7 */
+	char lcd_model_name[32];
 };
 
-
-
-struct lcd_fb_device {
+struct sunxi_lcd_fb_device {
 	struct list_head list;
 	struct device *dev;
+	struct device_node *panel_node;
 	char name[32];
 	u32 disp;
 
 	void *priv_data;
 	struct spi_device *spi_device;
 
-	struct disp_video_timings timings;
-	s32 (*init)(struct lcd_fb_device *p_lcd);
-	s32 (*exit)(struct lcd_fb_device *p_lcd);
-	s32 (*enable)(struct lcd_fb_device *p_lcd);
-	s32 (*fake_enable)(struct lcd_fb_device *p_lcd);
-	s32 (*disable)(struct lcd_fb_device *p_lcd);
-	s32 (*is_enabled)(struct lcd_fb_device *p_lcd);
-	s32 (*get_resolution)(struct lcd_fb_device *p_lcd, u32 *xres,
+	struct sunxi_lcd_fb_disp_video_timings timings;
+	s32 (*init)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*exit)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*enable)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*fake_enable)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*disable)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*is_enabled)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*get_resolution)(struct sunxi_lcd_fb_device *p_lcd, u32 *xres,
 			      u32 *yres);
-	s32 (*get_dimensions)(struct lcd_fb_device *dispdev, u32 *width,
+	s32 (*get_dimensions)(struct sunxi_lcd_fb_device *dispdev, u32 *width,
 			      u32 *height);
-	s32 (*set_color_temperature)(struct lcd_fb_device *dispdev, s32 color_temperature);
-	s32 (*get_color_temperature)(struct lcd_fb_device *dispdev);
-	s32 (*suspend)(struct lcd_fb_device *p_lcd);
-	s32 (*resume)(struct lcd_fb_device *p_lcd);
-	s32 (*set_bright)(struct lcd_fb_device *p_lcd, u32 bright);
-	s32 (*get_bright)(struct lcd_fb_device *p_lcd);
-	s32 (*backlight_enable)(struct lcd_fb_device *p_lcd);
-	s32 (*backlight_disable)(struct lcd_fb_device *p_lcd);
-	s32 (*pwm_enable)(struct lcd_fb_device *p_lcd);
-	s32 (*pwm_disable)(struct lcd_fb_device *p_lcd);
-	s32 (*power_enable)(struct lcd_fb_device *p_lcd, u32 power_id);
-	s32 (*power_disable)(struct lcd_fb_device *p_lcd, u32 power_id);
-	s32 (*pin_cfg)(struct lcd_fb_device *p_lcd, u32 bon);
-	s32 (*set_gamma_tbl)(struct lcd_fb_device *p_lcd, u32 *tbl,
-			      u32 size);
-	s32 (*set_bright_dimming)(struct lcd_fb_device *dispdev, u32 dimming);
-	s32 (*enable_gamma)(struct lcd_fb_device *p_lcd);
-	s32 (*disable_gamma)(struct lcd_fb_device *p_lcd);
-	s32 (*set_panel_func)(struct lcd_fb_device *lcd, char *name,
-			      struct disp_lcd_panel_fun *lcd_cfg);
-	s32 (*set_open_func)(struct lcd_fb_device *lcd, LCD_FUNC func,
+	s32 (*set_color_temperature)(struct sunxi_lcd_fb_device *dispdev,
+				     s32 color_temperature);
+	s32 (*get_color_temperature)(struct sunxi_lcd_fb_device *dispdev);
+	s32 (*suspend)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*resume)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*set_bright)(struct sunxi_lcd_fb_device *p_lcd, u32 bright);
+	s32 (*get_bright)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*backlight_enable)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*backlight_disable)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*pwm_enable)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*pwm_disable)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*power_enable)(struct sunxi_lcd_fb_device *p_lcd, u32 power_id);
+	s32 (*power_disable)(struct sunxi_lcd_fb_device *p_lcd, u32 power_id);
+	s32 (*pin_cfg)(struct sunxi_lcd_fb_device *p_lcd, u32 bon);
+	s32 (*set_gamma_tbl)(struct sunxi_lcd_fb_device *p_lcd, u32 *tbl,
+			     u32 size);
+	s32 (*set_bright_dimming)(struct sunxi_lcd_fb_device *dispdev,
+				  u32 dimming);
+	s32 (*enable_gamma)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*disable_gamma)(struct sunxi_lcd_fb_device *p_lcd);
+	s32 (*set_panel_func)(struct sunxi_lcd_fb_device *lcd, char *name,
+			      struct sunxi_lcd_fb_disp_lcd_panel_fun *lcd_cfg);
+	s32 (*set_open_func)(struct sunxi_lcd_fb_device *lcd, LCD_FUNC func,
 			     u32 delay);
-	s32 (*set_close_func)(struct lcd_fb_device *lcd, LCD_FUNC func,
+	s32 (*set_close_func)(struct sunxi_lcd_fb_device *lcd, LCD_FUNC func,
 			      u32 delay);
-	int (*gpio_set_value)(struct lcd_fb_device *p_lcd,
-			      unsigned int io_index, u32 value);
-	int (*gpio_set_direction)(struct lcd_fb_device *p_lcd,
-				  unsigned int io_index, u32 direction);
-	int (*get_panel_info)(struct lcd_fb_device *p_lcd,
-			       struct disp_panel_para *info);
-	int (*set_layer)(struct lcd_fb_device *p_lcd, struct fb_info *p_info);
-	int (*set_var)(struct lcd_fb_device *p_lcd, struct fb_info *p_info);
-	int (*blank)(struct lcd_fb_device *p_lcd, unsigned int en);
-	int (*cmd_write)(struct lcd_fb_device *p_lcd, unsigned char cmd);
-	int (*para_write)(struct lcd_fb_device *p_lcd, unsigned char para);
-	int (*cmd_read)(struct lcd_fb_device *p_lcd, unsigned char cmd,
-			unsigned char *rx_buf, unsigned char len);
-	int (*wait_for_vsync)(struct lcd_fb_device *p_lcd);
+	int (*gpio_set_value)(struct sunxi_lcd_fb_device *p_lcd, u32 io_index,
+			      u32 value);
+	int (*gpio_set_direction)(struct sunxi_lcd_fb_device *p_lcd,
+				  u32 io_index, u32 direction);
+	int (*get_panel_info)(struct sunxi_lcd_fb_device *p_lcd,
+			      struct sunxi_lcd_fb_disp_panel_para *info);
+	int (*set_layer)(struct sunxi_lcd_fb_device *p_lcd,
+			 struct fb_info *p_info);
+	int (*set_var)(struct sunxi_lcd_fb_device *p_lcd,
+		       struct fb_info *p_info);
+	int (*blank)(struct sunxi_lcd_fb_device *p_lcd, u32 en);
+	int (*cmd_write)(struct sunxi_lcd_fb_device *p_lcd, u8 cmd);
+	int (*para_write)(struct sunxi_lcd_fb_device *p_lcd, u8 para);
+	int (*cmd_read)(struct sunxi_lcd_fb_device *p_lcd, u8 cmd, u8 *rx_buf,
+			u8 len);
+	int (*qspi_cmd_write)(struct sunxi_lcd_fb_device *p_lcd, u8 cmd);
+	int (*qspi_para_write)(struct sunxi_lcd_fb_device *p_lcd, u8 cmd,
+			       u8 para);
+	int (*qspi_multi_para_write)(struct sunxi_lcd_fb_device *p_lcd, u8 cmd,
+				     u8 *tx_buf, u32 len);
+	int (*qspi_cmd_read)(struct sunxi_lcd_fb_device *p_lcd, u8 cmd,
+			     u8 *rx_buf, u8 len);
+	int (*wait_for_vsync)(struct sunxi_lcd_fb_device *p_lcd);
 };
 
-struct sunxi_disp_source_ops {
-	int (*sunxi_lcd_delay_ms)(unsigned int ms);
-	int (*sunxi_lcd_delay_us)(unsigned int us);
-	int (*sunxi_lcd_backlight_enable)(unsigned int screen_id);
-	int (*sunxi_lcd_backlight_disable)(unsigned int screen_id);
-	int (*sunxi_lcd_pwm_enable)(unsigned int screen_id);
-	int (*sunxi_lcd_pwm_disable)(unsigned int screen_id);
-	int (*sunxi_lcd_power_enable)(unsigned int screen_id,
-				       unsigned int pwr_id);
-	int (*sunxi_lcd_power_disable)(unsigned int screen_id,
-					unsigned int pwr_id);
-	int (*sunxi_lcd_set_panel_funs)(char *drv_name,
-					 struct disp_lcd_panel_fun *lcd_cfg);
-	int (*sunxi_lcd_pin_cfg)(unsigned int screen_id, unsigned int bon);
-	int (*sunxi_lcd_gpio_set_value)(unsigned int screen_id,
-					 unsigned int io_index, u32 value);
-	int (*sunxi_lcd_gpio_set_direction)(unsigned int screen_id,
-					     unsigned int io_index,
-					     u32 direction);
-	int (*sunxi_lcd_cmd_write)(unsigned int screen_id,
-					 unsigned char cmd);
-	int (*sunxi_lcd_para_write)(unsigned int screen_id,
-					 unsigned char para);
-	int (*sunxi_lcd_cmd_read)(unsigned int screen_id,
-					 unsigned char cmd, unsigned char *rx_buf, unsigned char len);
+struct sunxi_lcd_fb_disp_source_ops {
+	int (*sunxi_lcd_fb_delay_ms_ops)(u32 ms);
+	int (*sunxi_lcd_fb_delay_us_ops)(u32 us);
+	int (*sunxi_lcd_fb_backlight_enable_ops)(u32 screen_id);
+	int (*sunxi_lcd_fb_backlight_disable_ops)(u32 screen_id);
+	int (*sunxi_lcd_fb_pwm_enable_ops)(u32 screen_id);
+	int (*sunxi_lcd_fb_pwm_disable_ops)(u32 screen_id);
+	int (*sunxi_lcd_fb_power_enable_ops)(u32 screen_id, u32 pwr_id);
+	int (*sunxi_lcd_fb_power_disable_ops)(u32 screen_id, u32 pwr_id);
+	int (*sunxi_lcd_fb_set_panel_funs_ops)(
+		char *drv_name,
+		struct sunxi_lcd_fb_disp_lcd_panel_fun *lcd_cfg);
+	int (*sunxi_lcd_fb_pin_cfg_ops)(u32 screen_id, u32 bon);
+	int (*sunxi_lcd_fb_gpio_set_value_ops)(u32 screen_id, u32 io_index,
+					       u32 value);
+	int (*sunxi_lcd_fb_gpio_set_direction_ops)(u32 screen_id, u32 io_index,
+						   u32 direction);
+	int (*sunxi_lcd_fb_cmd_write_ops)(u32 screen_id, u8 cmd);
+	int (*sunxi_lcd_fb_para_write_ops)(u32 screen_id, u8 para);
+	int (*sunxi_lcd_fb_cmd_read_ops)(u32 screen_id, u8 cmd, u8 *rx_buf,
+					 u8 len);
+	int (*sunxi_lcd_fb_qspi_cmd_write_ops)(u32 screen_id, u8 cmd);
+	int (*sunxi_lcd_fb_qspi_para_write_ops)(u32 screen_id, u8 cmd, u8 para);
+	int (*sunxi_lcd_fb_qspi_multi_para_write_ops)(u32 screen_id, u8 cmd,
+						      u8 *tx_buf, u32 len);
+	int (*sunxi_lcd_fb_qspi_cmd_read_ops)(u32 screen_id, u8 cmd, u8 *rx_buf,
+					      u8 len);
 };
 
-enum disp_return_value {
+enum sunxi_lcd_fb_disp_return_value {
 	DIS_SUCCESS = 0,
 	DIS_FAIL = -1,
 	DIS_PARA_FAILED = -2,
@@ -387,5 +401,4 @@ enum disp_return_value {
 	DIS_PRIO_COLLSION = -11
 };
 
-
 #endif /* End of file */
diff --git a/drivers/video/sunxi/lcd_fb/lcd_fb_feature.h b/drivers/video/sunxi/lcd_fb/lcd_fb_feature.h
index 1bcbac9ad..ca7de34ca 100644
--- a/drivers/video/sunxi/lcd_fb/lcd_fb_feature.h
+++ b/drivers/video/sunxi/lcd_fb/lcd_fb_feature.h
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Copyright (c) 2007-2020 Allwinnertech Co., Ltd.
@@ -22,8 +22,9 @@
 extern "C" {
 #endif
 
-#if IS_ENABLED(CONFIG_ARCH_SUN50IW11) || IS_ENABLED(CONFIG_ARCH_SUN8IW20) || IS_ENABLED(CONFIG_ARCH_SUN55IW3) || IS_ENABLED(CONFIG_ARCH_SUN8IW21) \
-	|| IS_ENABLED(CONFIG_ARCH_SUN300IW1)
+#if IS_ENABLED(CONFIG_ARCH_SUN50IW11) || IS_ENABLED(CONFIG_ARCH_SUN8IW20) || \
+	IS_ENABLED(CONFIG_ARCH_SUN55IW3) ||                                  \
+	IS_ENABLED(CONFIG_ARCH_SUN8IW21) || IS_ENABLED(CONFIG_ARCH_SUN300IW1)
 #define SUPPORT_DBI_IF
 #endif
 
